# Testnet injector

A CLI tool to inject transactions or behaviors in an EcoMobiCoin blockchain.

## Components

This project heavily use the forked and adapted [ethers-rs](https://gitlab.limos.fr/ecomobicoin/ethers-rs).

### ETL

-   Extract CSV file e.g. `dataset-extract.csv` to `MobilityRecord`
-   Transform it with simulation params (relative time from earliest entry and behavior attributes)
-   Load data in memory with thread scheduled

### Sending Queue

## Usage

### Simulate tx & bx

To simulate Behaviors from a CSV Mobility dataset, run `cargo run simulate-bx-from-csv < data/dataset-extract.csv`

Options:

-   dataset e.g. CSV file
-   `total_simulation_duration` in seconds (or minutes ?)

### Send

Send tx or bx

Options:

-   `txs` Number of transactions to send
-   `bxs` Number of behaviors to send

In a near future:

-   `time_period` in seconds

### Mine

To mine a block from env vars `MINER_SIGNING_KEY` and `RPC_URL`, use `cargo run mine`

Options:

-   None yet

In a near futur:

-   quantity
-   timestamp
-   input

## Env vars

You can export env vars in the cli like `export RPC_URL="http://ecomobicoin-2.cri.local.isima.fr:10002"; testnet-injector mine`

Or you can use your user's cargo config file in (see https://doc.rust-lang.org/cargo/reference/config.html) or the project one `cargo/config.toml`.
And set the following content to set env vars:

```
[env]
MINER_SIGNING_KEY = ""
MNEMONIC = "abandon abandon abandon abandon abandon abandon abandon abandon abandon abandon abandon about"

RPC_URL=http://127.0.0.1:8545
CHAIN_ID = "636363"
DATABASE_URL = "./injector.db"
```

You can also specify `--rpc-url` and `--chain-id` as args in command line that will overwrite env vars.

## Ecomobicoin Simulation

> WORK IN PROGRESS

```mermaid
flowchart LR
    subgraph Configuration
    A[CSV Dataset] --> B[Simulation config]
    AA[Nodes & Miner config] --> B
    AAA[Chainspec] --> B
    end
    subgraph S[Simulation]
    subgraph D[Deployments]
    B --> D1[Deploy nodes]
    B --> D21[Deploy txbx CSV injector]
    B --> D22[Deploy txbx injectors cli]
    B --> D23[Deploy miners cli]
    B --> D3[Deploy block explorer]
    end
    D --> E[Run]
    end
    subgraph R[Reporting]
    E --> R1[Report]
    end
```

## Development

### Auto-Reloading Development Server

`cargo watch -x run`
